summaryrefslogtreecommitdiff
path: root/etc/rc.devd
diff options
context:
space:
mode:
authorRoy Marples <roy@marples.name>2008-03-25 14:06:05 +0000
committerRoy Marples <roy@marples.name>2008-03-25 14:06:05 +0000
commit55eb3794fb4ad563102d5ab30c1d5337a599b2e5 (patch)
tree0d052faeb050c1e18ba56f6f6189bff3ffca28c9 /etc/rc.devd
parent08aff6ef44ac5dc438d916b53aa61385f6d299f3 (diff)
downloadopenrc-55eb3794fb4ad563102d5ab30c1d5337a599b2e5.tar.gz
openrc-55eb3794fb4ad563102d5ab30c1d5337a599b2e5.tar.bz2
openrc-55eb3794fb4ad563102d5ab30c1d5337a599b2e5.tar.xz
Rework our folder structure so that we don't have OS specific dirs, making it easier to share init and conf files per OS.
Diffstat (limited to 'etc/rc.devd')
-rw-r--r--etc/rc.devd31
1 files changed, 31 insertions, 0 deletions
diff --git a/etc/rc.devd b/etc/rc.devd
new file mode 100644
index 0000000..f44d9ac
--- /dev/null
+++ b/etc/rc.devd
@@ -0,0 +1,31 @@
+#!/bin/sh
+# Copyright 2007-2008 Roy Marples <roy@marples.name>
+# All rights reserved. Released under the 2-clause BSD license.
+
+# Inform RC that we are in the background and hotplugged
+export IN_BACKGROUND=yes
+export IN_HOTPLUG=yes
+
+getmedia() {
+ ifconfig "$1" | while read line; do
+ case "${line}" in
+ media:" "*) echo "${line}"; return;;
+ esac
+ done
+}
+
+# Try and create an init script for network interfaces
+if [ ! -e /etc/init.d/"$1" -a ! -e /usr/local/init.d/"$1" ]; then
+ base=${1%%.*}
+ if [ "${base}" = "net" ]; then
+ # We only create links for pyhsical interfaces
+ [ -n "$(getmedia ${1#*.})" ] || exit 1
+ base="net.lo0"
+ fi
+ if [ -e /etc/init.d/"${base}" -a "${base}" != "$1" ]; then
+ ln -s "${base}" /etc/init.d/"$1"
+ fi
+fi
+
+# Run the init script
+exec /etc/init.d/"$1" "$2"